/* main.c:
 * This is an example of some of the stuff that "just works" as a result
 * of including the newlib_hooks.c file with a MicroMonitor application.
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include "monlib.h"
#include "cfg.h"

unsigned long AppStack[APPSTACKSIZE/4];

void
input_stuff(void)
{
	char	c;
	int		d1, d2, d3;

	/* getchar():
	 */
	printf("Gimme a character...\n");
	c = getchar();
	printf("You gave me '%c'\n",c);

	/* scanf():
	 */
	printf("Enter 3 whitespace-delimited integers\n");
	scanf("%d %d %d",&d1,&d2,&d3);
	printf("%d %d %d\n",d1,d2,d3);
}

void
env_stuff(void)
{
	printf("IPADD: %s\n",getenv("IPADD"));
	setenv("abc","def",1);
}

void
file_read(char *name)
{
	int		i=1;
	FILE	*fp;
	char	line[256];

	if ((fp = fopen(name,"r")) != (FILE *)NULL) {
		while(fgets(line,sizeof(line),fp) != NULL) {
			printf("%3d: ",i++);
			printf("%s",line);
		}
		fclose(fp);
	}
}

void
file_write(char *name)
{
	FILE	*fp;

	if ((fp = fopen(name,"w")) != (FILE *)NULL) {
		printf("Writing to '%s'...\n",name);
		fwrite("this is line1\n",14,1,fp);
		fwrite("this is line2\n",14,1,fp);
		fwrite("this is line3\n",14,1,fp);
		fclose(fp);
	}
}

void
file_append(char *name)
{
	FILE	*fp;

	if ((fp = fopen(name,"a")) != (FILE *)NULL) {
		printf("Appending to '%s'...\n",name);
		fwrite("this is line4\n",14,1,fp);
		fwrite("this is line5\n",14,1,fp);
		fwrite("this is line6\n",14,1,fp);
		fclose(fp);
	}
}

void
file_script(void)
{
	FILE	*fp;

	if ((fp = fopen("script,e,test","w")) != (FILE *)NULL) {
		printf("Writing three lines to executable 'script'...\n");
		fwrite("echo abcde\n",11,1,fp);
		fwrite("echo fghij\n",11,1,fp);
		fwrite("echo klmno\n",11,1,fp);
		fclose(fp);
	}
}

int
main(int argc, char *argv[])
{
	fprintf(stderr,"Hello errored world\n");

	input_stuff();
	env_stuff();
	file_read("monrc");
	file_write("filex");
	file_append("filex");
	file_script();
	exit(0);
}

void
__gccmain()
{
}

int
Cstart(void)
{
	char	**argv;
	int		argc;

	/* Connect the application to the monitor.  This must be done
	 * prior to the application making any other attempts to use the
	 * "mon_" functions provided by the monitor.
	 */
	monConnect((int(*)())(*(unsigned long *)MONCOMPTR),(void *)0,(void *)0);

	/* When the monitor starts up an application, it stores the argument
	 * list internally.  The call to mon_getargv() retrieves the arg list
	 * for use by this application...
	 */
	mon_getargv(&argc,&argv);

	/* Call main, then exit to monitor.
	 */
	main(argc,argv);

	mon_appexit(0);

	/* Won't get here. */
	return(0);
}

/* CstartAlt():
 * Demonstrates the use of the "call -a" command in uMon. 
 * For example, if for some reason you wanted to do this...
 * Load the application then load the symtbl file using
 * "make TARGET_IP=1.2.3.4 sym", then issue these commands:
 *
 *  tfs -v ld app
 *  call -a %CstartAlt one two three
 *
 * The "call -a" command in uMon correctly sets up the function
 * call parameters so that the following function would see 4
 * arguments (including arg0), with argv[1] thru argv[3] being
 * pointers to each of the number strings (i.e. "one", "two", "three")
 * and argv[0] being the ascii-coded-hex address of the function
 * CstartAlt.
 */
int
CstartAlt(int argc, char *argv[])
{
	monConnect((int(*)())(*(unsigned long *)MONCOMPTR),(void *)0,(void *)0);
	main(argc,argv);
	mon_appexit(0);
	return(0);
}
