/* Not all CPUs refer to the register pointing to the next instruction
 * address as "PC", so this definition allows it to be cpu specific...
 */
#define CPU_PC_REG	"PC"

/* List of the register names for the BF537 in the order they
 * are expected by the GDB 'g' command (read all registers).
 * Not sure why I need to pad the end of the table, but GDB appears
 * to want to see more registers than are actually in the CPU.
 */

static char *gdb_regtbl[] = {
	"R0", "R1", "R2", "R3", "R4", "R5", "R6", "R7",
	"P0", "P1", "P2", "P3", "P4", "P5", "SP", "FP",
	"I0", "I1", "I2", "I3", "M0", "M1", "M2", "M3", 
	"B0", "B1", "B2", "B3", "L0", "L1", "L2", "L3", 
	"A0X", "A0W", "A1X", "A1W", "ASTAT", "RETS", "LC0", "LT0",
	"LB0", "LC1", "LT1", "LB1", "CYCLES", "CYCLES2", "USP", "SEQSTAT",
	"SYSCFG", "RETI", "RETX", "RETN", "RETE", "PC","CC", 0,
	0,0,0,0,0
};


/*
 * List supported by 'dr' command:
 * 	"SP", "FP", "P5", "P4", "P3", "P2", "P1", "P0",
 * 	"R7", "R6", "R5", "R4", "R3", "R2", "R1", "R0",
 * 	"I3", "I2", "I1", "I0", "L3", "L2", "L1", "L0",
 * 	"B3", "B2", "B1", "B0", "M3", "M2", "M1", "M0",
 * 	"LC0","LC1","ASTAT", "SEQSTAT"
 * 
 * List from gdb command: "maintenance print raw-registers":
 * 	"R0", "R1", "R2", "R3", "R4", "R5", "R6", "R7",
 * 	"P0", "P1", "P2", "P3", "P4", "P5", "SP", "FP",
 * 	"I0", "I1", "I2", "I3", "M0", "M1", "M2", "M3", 
 * 	"B0", "B1", "B2", "B3", "L0", "L1", "L2", "L3", 
 * 	"A0X", "A0W", "A1X", "A1W", "ASTAT", "RETS", "LC0", "LT0",
 * 	"LB0", "LC1", "LT1", "LB1", "CYCLES", "CYCLES2", "USP", "SEQSTAT",
 * 	"SYSCFG", "RETI", "RETX", "RETN", "RETE", "PC","CC", 0,
 * 	0,0,0,0,0
 */


