// board specific defines for micro monitor
#define DEFAULT_BAUD_RATE   	38400
#define MON_CPU_CLOCK       	66666666
#define MEMCLK					66666666

#define LOOPS_PER_USEC			67

// These defines allow us to keep pci code endian neutral
#define PCI_ADD8  				3
#define PCI_ADD16 				2
#define BIG_ENDIAN				1	// big endian, when desired

// board specific defines needed by sed135x
#define SED1356_CRT				1
#define SED_MEM_BASE 			0xf0600000
#define SED_REG_BASE			0xf0400000
#define SED_STEP				1	// 16-bit port on 16-bit boundry
#define SED_REG(_x_)  			*(vuchar *)(SED_REG_BASE + ((ulong)_x_ * SED_STEP))	// Control/Status Registers
#define SED_REG16(_x_) 			*(vushort *)(SED_REG_BASE + ((ulong)_x_ * SED_STEP))	// Control/Status Registers, 16-bit mode
#define RD_FB16(_reg_,_val_) 	((_val_) = *((vushort *)((SED_MEM_BASE + ((ulong)_reg_ * SED_STEP)))))
#define WR_FB16(_reg_,_val_) 	(*((vushort *)((SED_MEM_BASE + ((ulong)_reg_ * SED_STEP)))) = (_val_))
#define H2SED(_x_)				(((((ushort)_x_) & 0xff00) >> 8) | ((((ushort)_x_) & 0x00ff) << 8))
//#define H2SED(_x_)				(_x_)

#define SED_DISP_MODE_CRT		1
#define SED_DISP_MODE_LCD		0


// board specific defines needed by ps2
#define PS2_BASE				0xf0800000
#define PS2_STEP				1	// 8-bit port on 8-bit boundry
#define PS2_REG(_x_)  			*(vuchar *)(PS2_BASE + (_x_ * PS2_STEP))	// 8-Bit port on 32-bit boundry      
//#define PS2_DEBUG
#define PS2_TIMEOUT				100000

//-----------------------------------------------------------------------------
// 405GP DUART - use the register defines in 16550.h
#define UART1_BASE				0xef600300
#define UART2_BASE				0xef600400
#define SIO_STEP				1	// internal 405GP UART is on 8-bit boundry
#define UARTA(_x_)  			*(vuchar *)(UART1_BASE + _x_)
#define UARTB(_x_)  			*(vuchar *)(UART2_BASE + _x_)


extern void uSleep(int);
