// cma278/9 specific declarations

// typedefs for PowerPC CPU's
typedef unsigned char 		cma_uint8;
typedef unsigned short		cma_uint16;
typedef unsigned long 		cma_uint32;
typedef unsigned long long 	cma_uint64; 

// The ADDx and PCI_ADDx defines are for big endian.  For little Endian
// CPU's they would all be 0.

// these offsets are for the CMA_MBD8() and CMA_MBD16() macros.  They
// are used to access IO devices that are either 8 or 16 bits wide and
// on a 64-bit boundry.
#define ADD8 7
#define ADD16 6

// These offsets are used to access PCI space, the V36x, the SED135x and the 
// StrataFLASH.  These devices are on a 32-bit boundry.
#define PCI_ADD8 3			// xor'ed with V3 PCI addresses
#define PCI_ADD16 2

#define BIG_ENDIAN		 	// big endian, when desired

// The 603 BAT's can be used to allow cached and uncached access to the
// CMA resources.  Since CMA ignores the upper 4 bits of the CPU address,
// we can use these offsets to create the desired spaces.
#define CMA_MBD_BASE		0xA0000000	   	// mbd base address, uncached
#define CMA_CACHED_BASE		0x00000000	   	// dram base address, cached
#define CMA_NON_CACHED_BASE	0xA0000000	   	// dram base address, uncached

#define LOOPS_PER_USEC		20				




