//==========================================================================
//
//      fs6377.h
//
// Author(s):    Michael Kelly - Cogent Computer Systems, Inc.
// Date:         03/03/03
// Description:  Defines and Macros for AMI FS6377 programmable PLL
//				 for CSB335 LH79520 SBC.
//
//==========================================================================

//--------------------------------------------------------------------------
// I2C Address
//
#define FS6377_I2C_ADD	0x58	// I2C Address of FS6377

//--------------------------------------------------------------------------
// Programmed values
//
// The following array data is derived from the
// the FS6377 Configuration Utility from AMI.
//
// Output Clk A1 Freq. = 25.000000MHz	LCD Clock
// Output Clk B1 Freq. = 25.000000MHz	10/100 PHY Clock
// Output Clk C1 Freq. = 24.000000MHz	CAN and LCD Clock
// Output Clk D1 Freq. =  3.686400MHz	UART Clock
//
const uchar fs6377_data_a[] = {
0x03,	// Register 00
0x4B,	// Register 01
0x40,	// Register 02
0x04,	// Register 03
0x60,	// Register 04
0x40,	// Register 05
0x32,	// Register 06
0x80,	// Register 07
0x94,	// Register 08
0x32,	// Register 09
0x80,	// Register 10
0xD4,	// Register 11
0x66,	// Register 12
0xF6,	// Register 13
0xF6,	// Register 14
0xE0	// Register 15
};

const uchar fs6377_data_b[] = {
0x03,	// Register 00
0x4B,	// Register 01
0x40,	// Register 02
0x04,	// Register 03
0x60,	// Register 04
0x40,	// Register 05
0x32,	// Register 06
0x80,	// Register 07
0x94,	// Register 08
0x32,	// Register 09
0x80,	// Register 10
0xD4,	// Register 11
0x66,	// Register 12
0xF6,	// Register 13
0xF6,	// Register 14
0xE0	// Register 15
};

