/* bootarg.h

    Author: David de la Cruz, Technology Rescue.
    email:  ddlc@techresc.net

	This include file defines TCPIP_PARAMS structure and related defs.

	Modification History :

	Version 1.0:
		25.11.2003 : new.
		06.01.2004 : added MACAdd field.
*/
#ifndef _BOOTARG_H
#define _BOOTARG_H

#define MONCOM_ADDR			0xA0000020


// TCPIP parameters section.
typedef struct _TCPIP_PARAMS
{
	unsigned int IpAdd;			// IP address.	
	unsigned int NetMask;		// Subnet mask.
	unsigned int GIpAdd;		// Gateway IP address.
	unsigned int DNS1;			// Primary DNS address.
	unsigned int DNS2;			// Secondary DNS address.
	unsigned int HostIp;		// Host address to be used by CERDISP/DBG.
	unsigned char MACAdd[6];	// MAC Address.
} TCPIP_PARAMS, *PTCPIP_PARAMS;

#define TCPIP_PTR_OFFSET	0x00000050

#define MEMORY_END_ADDR		0xA3E57000	// End of memory area to clear.
#define RESERVED_ADDR		0xA3F87000	// Start of reserved memory.
#define	RESERVED_END_ADDR	0xA3F8D000	// End of reserved memory.
#define DBG_PARAM_ADDR		0xA3F88A00	// Start address of dbg params.

// transport service IDs
// bit 6 is specified if passive kitl
// 0-127 reserved (0-63 for active mode, 64-127 for passive mode)
// 128-255 available for OEM use (128-191 for active mode, 192-255 for passive mode)
#define KTS_DEFAULT      0          // Default transport for platform
#define KTS_ETHER        1          // Ethernet transport
#define KTS_SERIAL       2          // Serial transport
#define KTS_USB          3          // USB transport
#define KTS_NONE         63         // no transport

#endif // _BOOTARG_H
