#ifndef ASSEMBLY_ONLY
#include "csb637_gpio.h"
#endif


// board specific defines for micro monitor
#define DEFAULT_BAUD_RATE   	38400
#define MON_CPU_CLOCK       	184320000


#define LOOPS_PER_USEC			3


#define MCK						MON_CPU_CLOCK/4


#define SDRAM_BASE				0x20000000
#define SRAM_BASE				0x00200000


// board specific defines needed by sed135x
#define SED_REG_BASE			0x30000000	// *CS2
#define SED_MEM_BASE 			(SED_REG_BASE + 0x00200000)
#define SED_STEP				1			// 16-bit port on 16-bit boundry

#define SED_REG16(_x_) 			*(vushort *)((ulong)SED_REG_BASE + (((ulong)_x_ * SED_STEP) ^ 0))	// Control/Status Registers, 16-bit mode
#define RD_FB16(_reg_,_val_) 	((_val_) = *((vushort *)(((ulong)SED_MEM_BASE + ((ulong)(_reg_ * SED_STEP) ^ 0)))))
#define WR_FB16(_reg_,_val_) 	(*((vushort *)(((ulong)SED_MEM_BASE + ((ulong)(_reg_ * SED_STEP)  ^ 0)))) = (_val_))

// LCD Defines for use with the CSB900lq
//
// The LCD frame buffer is fixed at 0x30020000
// Note that we access it 16-bits at a time.
//
#define SED_BUF_ADD				0x30200000
#define SED_BUF(_x_)			*(vushort *)(SED_BUF_ADD + _x_)	// Frame Buffer
#define USE_FONT8X8
#define SED_GET_PIXEL_ADD(_X_, _Y_)	(((_Y_ * PIXELS_PER_ROW) + _X_)*2)

//Big Endian
//#define H2SED(_x_)				(((((ushort)_x_) & 0xff00) >> 8) | ((((ushort)_x_) & 0x00ff) << 8))


//Little Endian
#define H2SED(_x_)				(_x_)


//#define SED_DBG
#define SED_GET_PHYS_ADD(_reg_) (vulong)(SED_MEM_BASE + ((_reg_ * SED_STEP) ^ 0))


#define SED_DISP_MODE_CRT		1
#define SED_DISP_MODE_LCD		0


#define SED1356_CRT			GPIO_tst(CRT_DET)



#define CORE_AT_FULL_SPEED 1


#define SED_FB_SIZE(_depth_)				(((PIXELS_PER_COL * PIXELS_PER_ROW) * _depth_) / 8)

#define SED_ROW_SIZE(_depth_)				((PIXELS_PER_ROW * _depth_) / 8)

#define SED_GET_ADD(_row_, _col_, _depth_)	(((((_row_ * PIXELS_PER_ROW) * FONT_HEIGHT) \
											  + (_col_ * FONT_WIDTH)) \
											  * _depth_) / 8)
