/* delay.S
 *
 * By David de la Cruz
 *
 * Modified by Technology Rescue.
 *	18.10.2002 : new lib file.
 *	07.02.2003 : Umon adaptation.
 *	10.02.2003 : Don't reset OS timer. Used time offset.
 */


.global delay

#include "pxa270.h"

	.text

/* Following function performs a wait.
 * Uses r0, r1 and r2.
 * Entry : r0 = time to wait.
 * Local :
 * r1 contains OSCR read value or temporary value for calcul.
 * r2 contains OSCR physical address.
 *
 * Don't reset OS timer to 0 because this timer is free running.
 */

delay:
	stmfd	sp!, {r0 - r2, lr}

/*	mov	r1, #CLOCK_TICK_RATE		/* Clock tick rate to obtain # clock tick. */
/*	mul	r0, r0, r1			/* r0 = # of Clock Ticks to wait for. */

	add	r0, r0, #2					/* increment time to wait by 2. */

	ldr	r2, =(TMR_BASE + TMR_OSCR0)	/* r2 = OSCR phys add. */
	ldr	r1, [r2]					/* read OS Timer Count. */
	add r0, r0, r1					/* time to reach. */

1:	ldr	r1, [r2]					/* read OS timer. */
	cmp	r0, r1						/* is time reached ?*/
	bgt	1b							/* no, loop. */

	ldmfd	sp!, {r0 - r2, pc}
