
//=============================================================================
//
//      cpu_gpio.h
//
//      CPU/Board Specific GPIO assignments
//
// Author(s):    Luis Torrico, Cogent Computer Systems, Inc.
// Date:         05/12/2008
// Description:  This file contains the GPIOIO usage for the CSB732
//
//
//=============================================================================

// PORT 1 - Virtual GPIO Bits 0-31
#define PORT1_VBIT      0
// Signal			    Bit		               Dir	Active	Usage
//#define	CF_RST_BIT	    BIT30	            // Out  High    Compact Flash Reset
//#define	CF_RST	        PORT1_VBIT + 30
//#define	AC_RST_BIT	    BIT15	            // Out  Low		AC97 Reset
//#define	AC_RST	        PORT1_VBIT + 15
//#define	LCD_BKL_BIT	    BIT9	            // Out  High    LCD Backlight Enable
//#define	LCD_BKL	        PORT1_VBIT + 9
//#define	GPIO3_BIT	    BIT8	            // In	High	MCU1_8 - set as GPIO Input, pulled high
//#define	GPIO3	        PORT1_VBIT + 8
//#define	GPIO2_BIT	    BIT7	            // In	High	MCU1_7 - set as GPIO Input, pulled high
//#define	GPIO2	        PORT1_VBIT + 7
//#define	I2C_INT_BIT	    BIT3	            // In	Low     I2C Interrupt
//#define	I2C_INT	        PORT1_VBIT + 3
//#define	EXP_INT_BIT	    BIT2	            // In	Low     Expansion Interrupt
//#define	EXP_INT	        PORT1_VBIT + 2
//#define	E_INT_BIT	    BIT1	            // In	High	LAN9211 Interrupt
//#define	E_INT	        PORT1_VBIT + 1

#define	LCD_BKL_BIT	    BIT1	            // Out  High    LCD Backlight Enable
#define	LCD_BKL	        PORT1_VBIT + 1

// Define initial direction (1 = output) and value
#define PORT1_DIR      (LCD_BKL_BIT)
// Define data value
#define PORT1_DR        0
       
// -----------------------------------------------------------------------------------------------
// PORT 2
#define PORT2_VBIT      32
// Signal			    Bit		               Dir	Active	Usage
//#define	GPIO7_BIT	    BIT16	            // In   High    MCU2_16 - set as GPIO Input, pulled high.  Shared with SPI1_CS1
//#define	GPIO7	        PORT2_VBIT + 16		//				GPIO7 will show up on pin A4, pin A4 and C11 are tied together
//#define	GPIO6_BIT	    BIT15	            // In   High    MCU2_15 - set as GPIO Input, pulled high.  Shared with SPI0_CS1
//#define	GPIO6	        PORT2_VBIT + 15
//#define	GPIO5_BIT	    BIT3	            // In   High    MCU2_3 - set as GPIO Input, pulled high
//#define	GPIO5		    PORT2_VBIT + 3
//#define	GPIO4_BIT	    BIT2	            // In   High    MCU2_2 - set as GPIO Input, pulled high
//#define	GPIO4		    PORT2_VBIT + 2
//#define	GPIO1_BIT	    BIT1	            // In   High    MCU2_1 - set as GPIO Input, pulled high
//#define	GPIO1		    PORT2_VBIT + 1
#define	GPIO0_BIT	    BIT0	            // In   High    MCU2_25 - set as GPIO Output, pulled high
#define	GPIO0		    PORT2_VBIT + 25

// Define initial direction (1 = output) and value
#define PORT2_DIR		GPIO0_BIT
// Define data value
#define PORT2_DR        0

// -----------------------------------------------------------------------------------------------
// PORT 3
#define PORT3_VBIT      64

// Signal			    Bit		               Dir	Active	Usage
//#define	GPIO9_BIT	    BIT3	            // In	High	MCU3_3 - set as GPIO Input, pulled high
//#define	GPIO9	        PORT3_VBIT + 3
//#define	GPIO8_BIT	    BIT2	            // In	High	MCU3_2 - set as GPIO Input, pulled high
//#define	GPIO8	        PORT3_VBIT + 2
//#define	VF_EN_BIT	    BIT1	            // Out	High	Fuse Voltage Enable - not used on CSB733
//#define	VF_EN	        PORT1_VBIT + 1
#define	PIRQ_BIT	    BIT5	            // In	Low     Interrupt
#define	PIRQ	        PORT3_VBIT + 5

// Define initial direction (1 = output) and value
#define PORT3_DIR		0
// Define data value
#define PORT3_DR 		PIRQ_BIT

