/* uartDriver.h:
 *	Declarations for the driver functions of UART. 
 *
 *	General notice:
 *	This code is part of a boot-monitor package developed as a generic base
 *	platform for embedded system designs.  As such, it is likely to be
 *	distributed to various projects beyond the control of the original
 *	author.  Please notify the author of any enhancements made or bugs found
 *	so that all may benefit from the changes.  In addition, notification back
 *	to the author will allow the new user to pick up changes that may have
 *	been made by other users after this version of the code was distributed.
 *
 *	Author:	Torsten Tetz, Bosch Security Systems
 */
#ifndef __UARTDRIVER_H
#define __UARTDRIVER_H

void initUART(int baud);
int ConsoleBaudSet(int baud);
int target_console_empty(void);
int target_putchar(char c);
int target_getchar(void);
int target_gotachar(void);

#endif	/* __UARTDRIVER_H */

