/* MicroMonitor configuration file for flash-based version
 * to run on Virtex-4 generic.
 */
#define optind umon_optind
#define optarg umon_optarg
#define getopt umon_getopt
#define bss_start __sbss_start
#define bss_end __bss_end

#define PLATFORM_NAME			"GigE Switch"
#define BOOTROMBASE_OVERRIDE	0x04000000
#define RAM_VECTOR_TABLE		0

#define CPU_NAME				"V4-PPC405"

#define SINGLE_FLASH_DEVICE
#define FLASHBANKS 				1
#define FLASH_TIMEOUT 			10000000
#define FLASH_BANK0_BASE_ADDR	0x04000000
#define FLASH_BANK0_WIDTH		2
#define FLASH_COPY_TO_RAM		1
#define FLASH_PROTECT_RANGE		"0-2"

#define TFSSTART				0x04060000
#define TFSEND					0x04fdffff
#define TFSSECTORCOUNT			124
#define TFSSPARE				0x04fe0000
#define TFSSPARESIZE			0x00020000
#define FLASH_BANK0_SIZE		0x01000000

#define TFS_EBIN_ELF			1

#define LOOPS_PER_SECOND		75000

#define ALLOCSIZE 				(64*1024)
#define MONSTACKSIZE			(4*1024)
#define CMDLINESIZE				128

#define INCLUDE_MALLOC			1
#define INCLUDE_MEMCMDS         1
#define INCLUDE_SHELLVARS		1
#define INCLUDE_XMODEM          1
#define INCLUDE_DISASSEMBLER    1
#define INCLUDE_UNZIP           1
#define INCLUDE_ETHERNET        1
#define INCLUDE_ICMP            1
#define INCLUDE_TFTP            1
#define INCLUDE_FLASH           1
#define INCLUDE_LINEEDIT        1
#define INCLUDE_DHCPBOOT        1
#define INCLUDE_EDIT            INCLUDE_FLASH
#define INCLUDE_TFS             INCLUDE_FLASH
#define INCLUDE_TFSAPI          INCLUDE_FLASH
#define INCLUDE_TFSSYMTBL       INCLUDE_FLASH
#define INCLUDE_TFSSCRIPT       INCLUDE_FLASH
#define INCLUDE_TFSCLI          INCLUDE_FLASH
#define INCLUDE_EE              1
#define INCLUDE_GDB             0
#define INCLUDE_STRACE          1
#define INCLUDE_CAST            0
#define INCLUDE_STRUCT          0
#define INCLUDE_REDIRECT        INCLUDE_TFS
#define INCLUDE_QUICKMEMCPY     1
#define INCLUDE_PROFILER        0
#define INCLUDE_BBC             0
#define INCLUDE_MEMTRACE        1
#define INCLUDE_STOREMAC        INCLUDE_FLASH
#define INCLUDE_VERBOSEHELP     1
#define INCLUDE_HWTMR	 	    0
#define INCLUDE_PORTCMD	 	    1
#define INCLUDE_USRLVL	 	    INCLUDE_TFS
#define INCLUDE_PCI		 	    0
#define INCLUDE_JFFS2	 	    1
#define INCLUDE_JFFS2ZLIB 	    1
#define INCLUDE_PHY 		    1


#include "inc_check.h"
